import "./Col.css";
import React, { ReactNode } from 'react';
declare type Width = number | string;
declare type Grow = boolean | number;
export interface ColProps {
    width?: Width;
    grow?: Grow;
    xs?: Width;
    xsGrow?: Grow;
    sm?: Width;
    smGrow?: Grow;
    md?: Width;
    mdGrow?: Grow;
    lg?: Width;
    lgGrow?: Grow;
    xl?: Width;
    xlGrow?: Grow;
    colWidthReduce?: number;
    children?: ReactNode;
}
export declare const defaultProps: {
    colWidthReduce: number;
};
export default function Col(props?: ColProps & React.HTMLProps<HTMLElement>): JSX.Element;
export {};
